-------------------------------------------------------------------------------
-- gpio_led0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library common_v1_00_a;
use common_v1_00_a.all;

library opb_gpio_v1_00_a;
use opb_gpio_v1_00_a.all;

entity gpio_led0_wrapper is
  port (
    OPB_Clk : in std_logic;
    OPB_Rst : in std_logic;
    OPB_ABus : in std_logic_vector(0 to 31);
    OPB_BE : in std_logic_vector(0 to 3);
    OPB_DBus : in std_logic_vector(0 to 31);
    OPB_RNW : in std_logic;
    OPB_select : in std_logic;
    OPB_seqAddr : in std_logic;
    GPIO_DBus : out std_logic_vector(0 to 31);
    GPIO_errAck : out std_logic;
    GPIO_retry : out std_logic;
    GPIO_toutSup : out std_logic;
    GPIO_xferAck : out std_logic;
    GPIO_IO_I : in std_logic_vector(0 to 0);
    GPIO_IO_O : out std_logic_vector(0 to 0);
    GPIO_IO_T : out std_logic_vector(0 to 0)
  );
end gpio_led0_wrapper;

architecture STRUCTURE of gpio_led0_wrapper is

  component opb_gpio is
    generic (
      C_BASEADDR : std_logic_vector;
      C_HIGHADDR : std_logic_vector;
      C_OPB_DWIDTH : integer;
      C_OPB_AWIDTH : integer;
      C_GPIO_WIDTH : integer;
      C_ALL_INPUTS : integer
    );
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      OPB_ABus : in std_logic_vector(0 to C_OPB_AWIDTH-1);
      OPB_BE : in std_logic_vector(0 to C_OPB_DWIDTH/8-1);
      OPB_DBus : in std_logic_vector(0 to C_OPB_DWIDTH-1);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      GPIO_DBus : out std_logic_vector(0 to C_OPB_DWIDTH-1);
      GPIO_errAck : out std_logic;
      GPIO_retry : out std_logic;
      GPIO_toutSup : out std_logic;
      GPIO_xferAck : out std_logic;
      GPIO_IO_I : in std_logic_vector(0 to C_GPIO_WIDTH-1);
      GPIO_IO_O : out std_logic_vector(0 to C_GPIO_WIDTH-1);
      GPIO_IO_T : out std_logic_vector(0 to C_GPIO_WIDTH-1)
    );
  end component;

begin

  gpio_led0 : opb_gpio
    generic map (
      C_BASEADDR => X"FFFFB000",
      C_HIGHADDR => X"FFFFB1FF",
      C_OPB_DWIDTH => 32,
      C_OPB_AWIDTH => 32,
      C_GPIO_WIDTH => 1,
      C_ALL_INPUTS => 0
    )
    port map (
      OPB_Clk => OPB_Clk,
      OPB_Rst => OPB_Rst,
      OPB_ABus => OPB_ABus,
      OPB_BE => OPB_BE,
      OPB_DBus => OPB_DBus,
      OPB_RNW => OPB_RNW,
      OPB_select => OPB_select,
      OPB_seqAddr => OPB_seqAddr,
      GPIO_DBus => GPIO_DBus,
      GPIO_errAck => GPIO_errAck,
      GPIO_retry => GPIO_retry,
      GPIO_toutSup => GPIO_toutSup,
      GPIO_xferAck => GPIO_xferAck,
      GPIO_IO_I => GPIO_IO_I,
      GPIO_IO_O => GPIO_IO_O,
      GPIO_IO_T => GPIO_IO_T
    );

end architecture STRUCTURE;
