#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:D:\lab\relazione\switchled\system.xmp
#################################################################

# Name of the Microprocessor system
# The hardware specification of the system is in file :
# D:\lab\relazione\switchled\system.mhs
# The software specification of the system is in file :
# D:\lab\relazione\switchled\system.mss

SYSTEM = system

MHSFILE = system.mhs

MSSFILE = system.mss

FPGA_ARCH = virtex2

DEVICE = xc2v2000ff896-4

LANGUAGE = vhdl

SEARCHPATHOPT = 

PLATGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) 

LIBGEN_OPTIONS = -mhs $(MHSFILE) -p $(FPGA_ARCH) $(SEARCHPATHOPT) \
                   $(MBLAZE_LIBG_OPT)

SIM_CMD = vsim

BEHAVIORAL_DO_SCRIPT = simulation/behavioral/$(SYSTEM).do

STRUCTURAL_DO_SCRIPT = simulation/structural/$(SYSTEM).do

TIMING_DO_SCRIPT = simulation/timing/$(SYSTEM).do

DEFAULT_SIM_DO_SCRIPT = $(BEHAVIORAL_DO_SCRIPT)

SIMGEN_OPTIONS = -p $(FPGA_ARCH) -lang $(LANGUAGE) $(SEARCHPATHOPT) -s mti

MBLAZE_OUTPUT = mblaze/code/executable.elf

LIBRARIES =  \
       mblaze/lib/libxil.a 


#################################################################
# EXTERNAL TARGETS
#################################################################
all:
	@echo "Makefile to build a Microprocessor system :"
	@echo "Run make with any of the following targets"
	@echo " "
	@echo "  netlist  : Generates the netlist for the given MHS "
	@echo "  bits     : Runs Implementation tools to generate the bitstream"
	@echo "  exporttopn:Export to ProjNav"
	@echo " "
	@echo "  libs     : Configures the sw libraries for this system"
	@echo "  program  : Compiles the program sources for all the processor instances"
	@echo "  bsp      : Generate a bsp for vxworks"
	@echo " "
	@echo "  init_bram: Initializes bitstream with BRAM data"
	@echo "  ace      : Generate ace file from bitstream and elf"
	@echo "  download : Downloads the bitstream onto the board"
	@echo " "
	@echo "  sim      : Generates HDL simulation models and runs simulator for chosen simulation mode"
	@echo "  simmodel : Generates HDL simulation models for chosen simulation mode"
	@echo "  behavioral:Generates behavioral HDL models with BRAM initialization"
	@echo "  structural:Generates structural simulation HDL models with BRAM initialization"
	@echo "  timing   : Generates timing simulation HDL models with BRAM initialization"
	@echo " "
	@echo "  netlistclean: Deletes netlist"
	@echo "  bitsclean: Deletes bit, ncd, bmm files"
	@echo "  hwclean  : Deletes implementation dir"
	@echo "  libsclean: Deletes sw libraries"
	@echo "  programclean: Deletes compiled ELF files"
	@echo "  swclean  : Deletes sw libraries and ELF files"
	@echo "  simclean : Deletes simulation dir"
	@echo "  clean    : Deletes all generated files/directories"
	@echo " "
	@echo "  make <target> : (Default)"
	@echo "      Creates a Microprocessor system using default initializations"
	@echo "      specified for each processor in MSS file"


bits: implementation/$(SYSTEM).bit

ace: implementation/$(SYSTEM).ace

netlist: implementation/$(SYSTEM).ngc

libs: $(LIBRARIES)

program: $(MBLAZE_OUTPUT) 

bsp: 
	@echo "To generate BSP, please specify VxWorks5_4/VxWorks5_5 as OS for atleast one PPC405 instance"

download: implementation/download.bit dummy
	@echo "*********************************************"
	@echo "Downloading Bitstream onto the target board"
	@echo "*********************************************"
	impact -batch etc/download.cmd

init_bram: implementation/download.bit

sim: $(DEFAULT_SIM_DO_SCRIPT)
	cd simulation/behavioral; \
	$(SIM_CMD) -do $(SYSTEM).do &

simmodel: $(DEFAULT_SIM_DO_SCRIPT)

behavioral_model: $(BEHAVIORAL_DO_SCRIPT)

structural_model: $(STRUCTURAL_DO_SCRIPT)

timing_model: $(TIMING_DO_SCRIPT)

clean: hwclean libsclean programclean simclean
	rm -f _impact.cmd

hwclean: netlistclean bitsclean
	rm -rf implementation synthesis xst hdl
	rm -rf xst.srp $(SYSTEM).srp

netlistclean:
	rm -f implementation/$(SYSTEM).ngc

bitsclean:
	rm -f implementation/$(SYSTEM).bit
	rm -f implementation/$(SYSTEM).ncd
	rm -f implementation/$(SYSTEM)_bd.bmm 

bitsclean:

simclean: 
	rm -rf simulation/behavioral

swclean: libsclean programclean
	@echo ""

libsclean: MBLAZE_LIBSCLEAN 

programclean: MBLAZE_PROGRAMCLEAN 

#################################################################
# TARGETS/MACROS FOR PROCESSOR MBLAZE
#################################################################

MBLAZE_SOURCES = code/switchled.c 

MBLAZE_HEADERS = 

MBLAZE_CC = mb-gcc
MBLAZE_CC_SIZE = mb-size
MBLAZE_CC_OPT = -O2
MBLAZE_CFLAGS = 
MBLAZE_CC_SEARCH = # -B
MBLAZE_LIBPATH = -L./mblaze/lib/ # -L
MBLAZE_INCLUDES = -I./mblaze/include/ # -I
MBLAZE_LFLAGS = # -l

MBLAZE_CC_FLOW =  # -[E|S|c]
MBLAZE_CC_PREPROC_FLAG = # -Wp,
MBLAZE_CC_ASM_FLAG = # -Wa,
MBLAZE_CC_LINKER_FLAG = # -Wl,
MBLAZE_LINKER_SCRIPT = #-Wl,-T -Wl,
MBLAZE_CC_DEBUG_FLAG = # -[g|gstabs]
MBLAZE_CC_GLOBPTR_FLAG= # -mxl-gp-opt
MBLAZE_MODE = executable
MBLAZE_LIBG_OPT = -$(MBLAZE_MODE) mblaze
MBLAZE_CC_SOFTMUL_FLAG= # -mno-xl-soft-mul 
MBLAZE_CC_START_ADDR_FLAG=  # -Wl,-defsym -Wl,_TEXT_START_ADDR=
MBLAZE_CC_STACK_SIZE_FLAG=  # -Wl,-defsym -Wl,_STACK_SIZE=
MBLAZE_OTHER_CC_FLAGS= $(MBLAZE_CC_FLOW) $(MBLAZE_CC_GLOBPTR_FLAG)  \
                  $(MBLAZE_CC_START_ADDR_FLAG) $(MBLAZE_CC_STACK_SIZE_FLAG)  \
                  $(MBLAZE_CC_SOFTMUL_FLAG)  \
                  $(MBLAZE_CC_PREPROC_FLAG) $(MBLAZE_CC_ASM_FLAG) $(MBLAZE_CC_LINKER_FLAG)  \
                  $(MBLAZE_LINKER_SCRIPT) $(MBLAZE_CC_DEBUG_FLAG) 

$(MBLAZE_OUTPUT) : $(MBLAZE_SOURCES) $(MBLAZE_HEADERS) $(LIBRARIES) __xps/mblaze_compiler.opt 
	$(MBLAZE_CC) $(MBLAZE_CFLAGS) $(MBLAZE_CC_OPT) $(MBLAZE_SOURCES) -o $(MBLAZE_OUTPUT)  \
	$(MBLAZE_OTHER_CC_FLAGS) $(MBLAZE_INCLUDES) $(MBLAZE_LIBPATH)  \
	-xl-mode-$(MBLAZE_MODE)  \
	$(MBLAZE_LFLAGS) 
	$(MBLAZE_CC_SIZE) $(MBLAZE_OUTPUT) 

MBLAZE_LIBSCLEAN:
	rm -rf mblaze/lib/

MBLAZE_PROGRAMCLEAN:
	rm -f $(MBLAZE_OUTPUT) 

#################################################################
# TARGETS/MACROS FOR XILINX IMPLEMENTATION FLOW
#################################################################


implementation/download.bit: implementation/$(SYSTEM).bit  $(MBLAZE_OUTPUT) 
	@cp -f implementation/$(SYSTEM)_bd.bmm .
	@echo "*********************************************"
	@echo "Initializing BRAM contents of the bitstream"
	@echo "*********************************************"
	bitinit $(MHSFILE) $(SEARCHPATHOPT)  -pe mblaze $(MBLAZE_OUTPUT)  -bt implementation/$(SYSTEM).bit -o implementation/download.bit
	@rm -f $(SYSTEM)_bd.bmm

implementation/$(SYSTEM).bit: implementation/$(SYSTEM).ngc etc/fast_runtime.opt __xps/xpsxflow.opt data/$(SYSTEM).ucf etc/bitgen.ut
	@echo "Copying Xilinx Implementation tool scripts.."
	@cp -f etc/bitgen.ut implementation/bitgen.ut
	@cp -f etc/fast_runtime.opt implementation/
	@cp -f data/$(SYSTEM).ucf implementation/$(SYSTEM).ucf
	@echo "*********************************************"
	@echo "Running Xilinx Implementation tools.."
	@echo "*********************************************"
	xflow -wd implementation -p $(DEVICE) -implement fast_runtime.opt $(SYSTEM).ngc
	cd implementation; bitgen -w -f bitgen.ut $(SYSTEM)

exporttopn: 
	@echo You have chosen XPS for implementation tool flow.
	@echo Please select ProjNav as your implementation flow in Project Options or use commad xset pnproj <nplfile> in batch mode

implementation/$(SYSTEM).ace:
	@echo "You must have exactly one ppc405 to generate ace file"

implementation/$(SYSTEM).ngc implementation/$(SYSTEM).bmm: \
$(MHSFILE) __xps/platgen.opt
	@echo "*********************************************"
	@echo "Creating system netlist for hardware specification.."
	@echo "*********************************************"
	platgen $(PLATGEN_OPTIONS) -st xst  $(MHSFILE)
	@echo "Running synthesis..."
	bash -c "cd synthesis; ./synthesis.sh; cd .."

$(LIBRARIES): $(MHSFILE) $(MSSFILE) __xps/libgen.opt
	@echo "*********************************************"
	@echo "Creating software libraries..."
	@echo "*********************************************"
	libgen $(LIBGEN_OPTIONS) $(MSSFILE)

#################################################################
# TARGETS/MACROS FOR SIMULATION FLOW
#################################################################


$(BEHAVIORAL_DO_SCRIPT): $(MHSFILE) __xps/simgen.opt \
 $(MBLAZE_OUTPUT) 
	@echo "*********************************************"
	@echo "Creating behavioral simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -m behavioral $(MHSFILE)  -pe mblaze $(MBLAZE_OUTPUT) 

$(STRUCTURAL_DO_SCRIPT): $(MHSFILE) __xps/simgen.opt \
 $(MBLAZE_OUTPUT)  \
implementation/mblaze_wrapper.ngc \
implementation/bram_wrapper.ngc \
implementation/bram_data_ctrl_wrapper.ngc \
implementation/bram_inst_ctrl_wrapper.ngc \
implementation/jtag_wrapper.ngc \
implementation/uart_wrapper.ngc \
implementation/data_lmb_wrapper.ngc \
implementation/inst_lmb_wrapper.ngc \
implementation/opb_bus_wrapper.ngc \
implementation/gpio_switch0_wrapper.ngc \
implementation/gpio_led0_wrapper.ngc
	@echo "*********************************************"
	@echo "Creating structural simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m structural $(MHSFILE)  -pe mblaze $(MBLAZE_OUTPUT) 

$(TIMING_DO_SCRIPT): $(MHSFILE) __xps/simgen.opt \
 $(MBLAZE_OUTPUT)  \
implementation/$(SYSTEM).bit
	@echo "*********************************************"
	@echo "Creating timing simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m timing $(MHSFILE)  -pe mblaze $(MBLAZE_OUTPUT) 


implementation/mblaze_wrapper.ngc \
implementation/bram_wrapper.ngc \
implementation/bram_data_ctrl_wrapper.ngc \
implementation/bram_inst_ctrl_wrapper.ngc \
implementation/jtag_wrapper.ngc \
implementation/uart_wrapper.ngc \
implementation/data_lmb_wrapper.ngc \
implementation/inst_lmb_wrapper.ngc \
implementation/opb_bus_wrapper.ngc \
implementation/gpio_switch0_wrapper.ngc \
implementation/gpio_led0_wrapper.ngc: $(MHSFILE) __xps/platgen.opt
	platgen $(PLATGEN_OPTIONS) $(MHSFILE)

dummy:
	@echo ""

