// gpiotest.c   
 
#include "gpio.h"
#include "xparameters.h"
#include "xgpio.h"

int main( int argc, char ** argv)
{
   XGpio button, y_modif, cr_modif, cb_modif; 
   Xuint8 k=0;
   Xuint8 k_prev=1;  
   Xuint16 Y_value, Cr_value, Cb_value=0; 
   Xuint8 pb3, pb4,pb5,pb6,pb7,pb8,pb9,pb10=0;
   
   program_video();
    
   xil_printf("\r\n\r\n**************************************\r\n");
   xil_printf("*  MicroBlaze and Multimedia Board   *\r\n");
   xil_printf("* Video Editing Infrastructure v.1.0 *\r\n");
   xil_printf("*     Created by Martino Jerian      *\r\n");
   xil_printf("* Universita' degli Studi di Trieste *\r\n");
   xil_printf("*        Corso di Elettronica        *\r\n");
   xil_printf("*        prof. Stefano Marsi         *\r\n");
   xil_printf("**************************************\r\n\r\n");
   xil_printf("(Y-10) (Y+10)  (Cr-10)(Cr+10)  (Cb-10)(Cb+10)\r\n");
   xil_printf("  ^      ^        ^      ^        ^      ^\r\n");
   xil_printf("(pb3)  (pb4)    (pb5)  (pb6)    (pb7)  (pb8)\r\n\r\n");

   XGpio_Initialize(&button,XPAR_GPIO_BUTTON_IN_DEVICE_ID ); 
   XGpio_SetDataDirection(&button, 0x00000000);  
   	
   XGpio_Initialize(&y_modif,XPAR_GPIO_Y_DEVICE_ID ); 
   XGpio_SetDataDirection(&y_modif, 0xffffffff); 
   XGpio_Initialize(&cr_modif,XPAR_GPIO_CR_DEVICE_ID ); 
   XGpio_SetDataDirection(&cr_modif, 0xffffffff);   
   XGpio_Initialize(&cb_modif,XPAR_GPIO_CB_DEVICE_ID ); 
   XGpio_SetDataDirection(&cb_modif, 0xffffffff); 
   
   while(1)
   {
	  k = XGpio_DiscreteRead(&button);
      if (k!=k_prev)
	  { 
	     if (k%2<1) {pb3=0;} else {pb3=1;}
	     if (k%4<2) {pb4=0;} else {pb4=1;}
         if (k%8<4) {pb5=0;} else {pb5=1;}
	     if (k%16<8) {pb6=0;} else {pb6=1;}
	     if (k%32<16) {pb7=0;} else {pb7=1;}
	     if (k%64<32) {pb8=0;} else {pb8=1;}
	     if (k%128<64) {pb9=0;} else {pb9=1;}
	     if (k%256<128) {pb10=0;} else {pb10=1;}

	     if ((pb4==1)&&(Y_value<1024)) Y_value = Y_value + 10; 
	     if ((pb3==1)&&(Y_value>0)) Y_value = Y_value - 10;
		 if ((pb6==1)&&(Cr_value<1024)) Cr_value = Cr_value + 10; 
	     if ((pb5==1)&&(Cr_value>0)) Cr_value = Cr_value - 10; 
	     if ((pb8==1)&&(Cb_value<1024)) Cb_value = Cb_value + 10; 
	     if ((pb7==1)&&(Cb_value>0)) Cb_value = Cb_value - 10;  
	   
	     xil_printf("Y_value + %d ",Y_value); 	
         xil_printf("  Cr_value + %d ",Cr_value); 
		 xil_printf("  Cb_value + %d ",Cb_value); 
		 xil_printf("\r\n");
	   
	  }
	   
	  XGpio_DiscreteWrite(&y_modif, Y_value);
	  XGpio_DiscreteWrite(&cr_modif, Cr_value);
	  XGpio_DiscreteWrite(&cb_modif, Cb_value);
      k_prev=k;   
   }
   return 0;
}
