-------------------------------------------------------------------------------
-- clock_gen_inst_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library microblaze_brd_zbt_clkgen_v1_00_a;
use microblaze_brd_zbt_clkgen_v1_00_a.all;

entity clock_gen_inst_wrapper is
  port (
    master_clock_p : in std_logic;
    line_locked_clock1 : in std_logic;
    extend_dcm_reset_p : in std_logic;
    memory_bank2_clk_p : out std_logic;
    clk_27mhz : out std_logic;
    line_locked_clock : out std_logic;
    clk_81mhz : out std_logic;
    fpga_reset : out std_logic;
    enet_slew_p : out std_logic_vector(1 downto 0);
    pause_p : out std_logic;
    mdio_p : out std_logic;
    mdc_p : out std_logic;
    startup_p : out std_logic
  );
end clock_gen_inst_wrapper;

architecture STRUCTURE of clock_gen_inst_wrapper is

  component microblaze_brd_zbt_clkgen is
    port (
      master_clock_p : in std_logic;
      line_locked_clock1 : in std_logic;
      extend_dcm_reset_p : in std_logic;
      memory_bank2_clk_p : out std_logic;
      clk_27mhz : out std_logic;
      line_locked_clock : out std_logic;
      clk_81mhz : out std_logic;
      fpga_reset : out std_logic;
      enet_slew_p : out std_logic_vector(1 downto 0);
      pause_p : out std_logic;
      mdio_p : out std_logic;
      mdc_p : out std_logic;
      startup_p : out std_logic
    );
  end component;

begin

  clock_gen_inst : microblaze_brd_zbt_clkgen
    port map (
      master_clock_p => master_clock_p,
      line_locked_clock1 => line_locked_clock1,
      extend_dcm_reset_p => extend_dcm_reset_p,
      memory_bank2_clk_p => memory_bank2_clk_p,
      clk_27mhz => clk_27mhz,
      line_locked_clock => line_locked_clock,
      clk_81mhz => clk_81mhz,
      fpga_reset => fpga_reset,
      enet_slew_p => enet_slew_p,
      pause_p => pause_p,
      mdio_p => mdio_p,
      mdc_p => mdc_p,
      startup_p => startup_p
    );

end architecture STRUCTURE;
