-------------------------------------------------------------------------------
-- demultiplexer_inst_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library YCrCb_demultiplexer;
use YCrCb_demultiplexer.all;

entity demultiplexer_inst_wrapper is
  port (
    reset : in std_logic;
    clock : in std_logic;
    YCrCb_in : in std_logic_vector(9 downto 0);
    Y_out : out std_logic_vector(9 downto 0);
    Cr_out : out std_logic_vector(9 downto 0);
    Cb_out : out std_logic_vector(9 downto 0)
  );
end demultiplexer_inst_wrapper;

architecture STRUCTURE of demultiplexer_inst_wrapper is

  component ycrcb_demultiplexer is
    port (
      reset : in std_logic;
      clock : in std_logic;
      YCrCb_in : in std_logic_vector(9 downto 0);
      Y_out : out std_logic_vector(9 downto 0);
      Cr_out : out std_logic_vector(9 downto 0);
      Cb_out : out std_logic_vector(9 downto 0)
    );
  end component;

begin

  demultiplexer_inst : ycrcb_demultiplexer
    port map (
      reset => reset,
      clock => clock,
      YCrCb_in => YCrCb_in,
      Y_out => Y_out,
      Cr_out => Cr_out,
      Cb_out => Cb_out
    );

end architecture STRUCTURE;
