-------------------------------------------------------------------------------
-- gpio2iic_inst_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library gpio2iic_v1_00_b;
use gpio2iic_v1_00_b.all;

entity gpio2iic_inst_wrapper is
  port (
    gpio_data_i2 : out std_logic;
    gpio_data_i3 : out std_logic;
    gpio_data_o2 : in std_logic;
    gpio_data_o3 : in std_logic;
    gpio_data_o4 : in std_logic;
    video_encoder_sclk_p : out std_logic;
    video_encoder_data_p : out std_logic;
    i2c_clock_p : out std_logic;
    i2c_data_p : out std_logic
  );
end gpio2iic_inst_wrapper;

architecture STRUCTURE of gpio2iic_inst_wrapper is

  component gpio2iic is
    port (
      gpio_data_i2 : out std_logic;
      gpio_data_i3 : out std_logic;
      gpio_data_o2 : in std_logic;
      gpio_data_o3 : in std_logic;
      gpio_data_o4 : in std_logic;
      video_encoder_sclk_p : out std_logic;
      video_encoder_data_p : out std_logic;
      i2c_clock_p : out std_logic;
      i2c_data_p : out std_logic
    );
  end component;

begin

  gpio2iic_inst : gpio2iic
    port map (
      gpio_data_i2 => gpio_data_i2,
      gpio_data_i3 => gpio_data_i3,
      gpio_data_o2 => gpio_data_o2,
      gpio_data_o3 => gpio_data_o3,
      gpio_data_o4 => gpio_data_o4,
      video_encoder_sclk_p => video_encoder_sclk_p,
      video_encoder_data_p => video_encoder_data_p,
      i2c_clock_p => i2c_clock_p,
      i2c_data_p => i2c_data_p
    );

end architecture STRUCTURE;
