-------------------------------------------------------------------------------
-- my_multiplexer_elab_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library multiplexer_elab;
use multiplexer_elab.all;

entity my_multiplexer_elab_wrapper is
  port (
    reset : in std_logic;
    clock : in std_logic;
    Y_modif : in std_logic_vector(9 downto 0);
    Cr_modif : in std_logic_vector(9 downto 0);
    Cb_modif : in std_logic_vector(9 downto 0);
    Y_in : in std_logic_vector(9 downto 0);
    Cr_in : in std_logic_vector(9 downto 0);
    Cb_in : in std_logic_vector(9 downto 0);
    YCrCb_out : out std_logic_vector(9 downto 0)
  );
end my_multiplexer_elab_wrapper;

architecture STRUCTURE of my_multiplexer_elab_wrapper is

  component multiplexer_elab is
    port (
      reset : in std_logic;
      clock : in std_logic;
      Y_modif : in std_logic_vector(9 downto 0);
      Cr_modif : in std_logic_vector(9 downto 0);
      Cb_modif : in std_logic_vector(9 downto 0);
      Y_in : in std_logic_vector(9 downto 0);
      Cr_in : in std_logic_vector(9 downto 0);
      Cb_in : in std_logic_vector(9 downto 0);
      YCrCb_out : out std_logic_vector(9 downto 0)
    );
  end component;

begin

  my_multiplexer_elab : multiplexer_elab
    port map (
      reset => reset,
      clock => clock,
      Y_modif => Y_modif,
      Cr_modif => Cr_modif,
      Cb_modif => Cb_modif,
      Y_in => Y_in,
      Cr_in => Cr_in,
      Cb_in => Cb_in,
      YCrCb_out => YCrCb_out
    );

end architecture STRUCTURE;
