-------------------------------------------------------------------------------
-- my_video_block_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library video_block;
use video_block.all;

entity my_video_block_wrapper is
  port (
    reset : in std_logic;
    clock : in std_logic;
    YCrCb_in : in std_logic_vector(9 downto 0);
    pixel_data_in : in std_logic_vector(9 downto 0);
    synch_data_in : in std_logic_vector(9 downto 0);
    YCrCb_out : out std_logic_vector(9 downto 0);
    pixel_data_out : out std_logic_vector(9 downto 0);
    synch_data_out : out std_logic_vector(9 downto 0);
    reset_out : out std_logic
  );
end my_video_block_wrapper;

architecture STRUCTURE of my_video_block_wrapper is

  component video_block is
    port (
      reset : in std_logic;
      clock : in std_logic;
      YCrCb_in : in std_logic_vector(9 downto 0);
      pixel_data_in : in std_logic_vector(9 downto 0);
      synch_data_in : in std_logic_vector(9 downto 0);
      YCrCb_out : out std_logic_vector(9 downto 0);
      pixel_data_out : out std_logic_vector(9 downto 0);
      synch_data_out : out std_logic_vector(9 downto 0);
      reset_out : out std_logic
    );
  end component;

begin

  my_video_block : video_block
    port map (
      reset => reset,
      clock => clock,
      YCrCb_in => YCrCb_in,
      pixel_data_in => pixel_data_in,
      synch_data_in => synch_data_in,
      YCrCb_out => YCrCb_out,
      pixel_data_out => pixel_data_out,
      synch_data_out => synch_data_out,
      reset_out => reset_out
    );

end architecture STRUCTURE;
