//-----------------------------------------------------------------------------
// clock_gen_wrapper.v
//-----------------------------------------------------------------------------

module clock_gen_wrapper
  (
    MASTER_CLOCK_P,
    ALTERNATE_CLOCK_P,
    MEM_CLK_FBOUT_P,
    MEM_CLK_FBIN_P,
    EXTEND_DCM_RESET_P,
    clk_27mhz,
    clk_54mhz,
    clk_108mhz,
    pixel_clock,
    memory_27mhz,
    memory_54mhz,
    memory_108mhz,
    pal_mode,
    fpga_reset
  );
  input MASTER_CLOCK_P;
  input ALTERNATE_CLOCK_P;
  output MEM_CLK_FBOUT_P;
  input MEM_CLK_FBIN_P;
  input EXTEND_DCM_RESET_P;
  output clk_27mhz;
  output clk_54mhz;
  output clk_108mhz;
  output pixel_clock;
  output memory_27mhz;
  output memory_54mhz;
  output memory_108mhz;
  input pal_mode;
  output fpga_reset;

  clockgen
    clock_gen (
      .MASTER_CLOCK_P ( MASTER_CLOCK_P ),
      .ALTERNATE_CLOCK_P ( ALTERNATE_CLOCK_P ),
      .MEM_CLK_FBOUT_P ( MEM_CLK_FBOUT_P ),
      .MEM_CLK_FBIN_P ( MEM_CLK_FBIN_P ),
      .EXTEND_DCM_RESET_P ( EXTEND_DCM_RESET_P ),
      .clk_27mhz ( clk_27mhz ),
      .clk_54mhz ( clk_54mhz ),
      .clk_108mhz ( clk_108mhz ),
      .pixel_clock ( pixel_clock ),
      .memory_27mhz ( memory_27mhz ),
      .memory_54mhz ( memory_54mhz ),
      .memory_108mhz ( memory_108mhz ),
      .pal_mode ( pal_mode ),
      .fpga_reset ( fpga_reset )
    );

endmodule

